
#include <dht.h>
#include <Time.h>
#define dht_apin A0  //DEFINIMOS QUE EL PIN A0 SERA LA ENTRADA DE DATOS ANALOGICOS DE NUESTRO SENSOR DE HUMEDAD
dht DHT;
double Tmax=0.00; //inicializamos una variable
double Tmin=100.00; //inicializamos la variable
double Tmedia=0.00;// inicializamos la variable
double KT=0.162; //VALOR CONSTANTE PARA REGIONES DE INTERIOR
double Rs;
double ETo;
double EToMes=0.00;
double Kc=0.00;
double Ro=34.7; //ESTE VALOR SE LO TENDREMOS QUE VARIAR MENSUALMENTE
int TiempoValvulaONMs =0;
////////////////////////////PARTE DEL PLVUIOMETRO/////////////////////////////////////
const byte pinPluviometro       = 3;    // Definición del pin donde conectarás el Pluviómetro
bool Pluviometro;               // Estado actual del switch del pluviometro
bool PluviometroAnt  = LOW;             // Estado anterior del switch del pluviometro
unsigned int cuentaPrecipitacion  = 0;    // Contador de precipitaciones
unsigned int cuentaPrecipitacionAnt = 0;    // Valor anterior del contador de precipitaciones 
                        // solo para presentar cuando haya cambios
float Precipitacion;              // variable que lleva los mm de agua caídos
float PrecipitacionDia=0;
float PrecipitacionMes=0;

////////////////////////////////////////////SETUP//////////////////////////////////////////////////

void setup() {
  pinMode(13, OUTPUT);
  pinMode(7, OUTPUT); //pin que enviara señal encendid/apagado de la electrovalvula via radio
  pinMode(pinPluviometro, INPUT);      //el pin pluviometro será una entrada  
    Serial.begin(9600);
    setTime(00,00,00,01,07,2016);//INICIALIZAMOS LA HORA
    delay(500);//Delay to let system boot
    Serial.println("SENSOR DE HUMEDAD Y TEMPERATURA DHT11\n\n");
    delay(1000);//Wait before accessing Sensor 
}//end "setup()"

//////////////////////////////////LOOP////////////////////////////// 
void loop(){

for (int k=1; k<=8; k++){

  if(k==1){
    Serial.println("                     MARZO                ");
    Ro=27.5;
    Kc=0.3;   //valores de Kc según la tabla
  }else if(k==2){
    Serial.println("                     ABRIL                ");
    Ro=34.7;
    Kc=0.3;
  }else if(k==3){
    Serial.println("                     MAYO              ");
    Ro=39.6;
    Kc=0.5;
  }
///.................... el resto de meses habría que ponerlos por ahorro de codigo nos los ahorramos
    
/////////////////////////////////////////CÁLCULO DE VALORES POR MES//////////////////////////////////////////
for(int j=1; j<31;  j++){ 
    
  Serial.print(" DIA  ");
  Serial.println(j);
  EToMes=EToMes+ETo;     //acumulamos los valores de Evapotranspiración para calcular su valor mensual

///////////////////////////PARTE DE LA SEÑAL QUE SE ENVIARÁ POR RADIO HASTA LA UNIDAD RECEPTORA CONECTADA A LAS ELECTROVALVULAS/////////////////
//deberemos enviar un 1 logico via radio hacia la unidad receptora conectada directamente a la electrovalvula////
  digitalWrite (7,LOW);
  int Actual=millis();
  if(Actual>=TiempoValvulaONMs-millis()){  //durante el tiempo de riego el sensor esta activo
    digitalWrite (7,HIGH);
  }
///////////////////////////////////////////////////////////////////////////////////////////////////////////


 
for(int i=1; i<25; i++){   //DIARIAMENTE CALCULAREMOS VALORES DE HUMEDAD Y TEMPERATURA CADA HORA (CADA 3.600.000 ms)

//LOS PRIMEROS INSTANTES DE CADA HORA LEEREMOS VALORES DEL SENSOR DE TEMP Y HUMEDAD EL RESTO DEL TIEMPO ACTIVAREMOS EL SENSOR DE PLUVIOMETRO
  do{    
    Pluviometro = digitalRead(pinPluviometro);  // Leeremos de la entrada digital el valor de pluviómetro

    if (Pluviometro == HIGH && PluviometroAnt == LOW){ // solo voy a considera un cambio 0->1 en el Pluviometro
      cuentaPrecipitacion =cuentaPrecipitacion + 1; //Contamos pulsos
    }      
    PluviometroAnt = Pluviometro;     // esto actualiza el estado anterior de Pluviometro
    if (cuentaPrecipitacion != cuentaPrecipitacionAnt) {
      Precipitacion = cuentaPrecipitacion * 0.1;    // CADA PULSO QUE SE LEA EQUIVALE A 0.1 mm, MULTIPLICO PARA OBTENER EL VALOR REAL
      Serial.print("LLUVIA REGISTRADA = ");
      Serial.print(Precipitacion);
      Serial.println(" mm");
      cuentaPrecipitacionAnt = cuentaPrecipitacion;
    }
  }while (millis()<=200*i);    //el valor numérico equivale a los milisigundos al comienzo de las horas que dedicaremos a la lectura como vamos a trabajar cada hora
  //este valor deberá ser de 3.600.000 para simplificar las comprobaciones tomaremos un valor de tiempo menor, así podremos comprobar el correcto funcionamiento
  //del programa

   ////////////////////////AHORA ACTUA EL SENSOR DE TEMPERATURA Y HUMEDAD/////////////////////
DHT.read11(dht_apin);

time_t t = now();

      Serial.print("Fecha :  ");
      Serial.print(day(t));
      Serial.print(+ "/") ;
      Serial.print(month(t));
      Serial.print(+ "/") ;
      Serial.print(year(t)); 
      Serial.print( "       ") ;
      Serial.print("Hora :  ");
      Serial.print(hour(t));  
      Serial.print(+ ":") ;
      Serial.print(minute(t));
      Serial.print(":") ;
      Serial.println(second(t));

    
    Serial.print("HUMEDAD RELATIVA DEL INVERNADERO = ");
    Serial.print(DHT.humidity);
    Serial.print("%  ");
    Serial.print("TEMPERATURA = ");
    Serial.print(DHT.temperature); 
    Serial.println("C  ");
    Tmedia=DHT.temperature+Tmedia;
    Serial.println("");
 //////////////////////CALCULO DE LAS TEMPERATURAS MAXIMAS Y MINIMAS/////////////////////////
    if(DHT.temperature>=Tmax){
        Tmax=DHT.temperature;
    }
    if(DHT.temperature<=Tmin){
        Tmin=DHT.temperature;
    }
    delay(2000);  //ESTE DELAY ES PARA DARLE TIEMPO AL PROGRAMA QUE EJECUTE LAS ACCIONES DE CACLULOS
    //un valor de dos segundos es adecuado para realizar este proceso
}//end for i

//RESULTADOS POR PANTALLA DIARIOS//
  Tmedia=Tmedia/24;
  Serial.print("La temperatura media diaria fue de :    ");
  Serial.println(Tmedia);

  Serial.print("TMAX DIARIA = ");
  Serial.print(Tmax); 
  Serial.print(" TMIN DIARIA = ");
  Serial.print(Tmin);
  Serial.print("\n") ;
  Serial.print("RADIACION SOLAR EXTRATERRESTRE DE :  ");
  Serial.print(Ro*0.408);
  Serial.println("/n mm/dia  ");
  Serial.print("RADIACION SOLAR INCIDENTE DE :   ");
  Rs=Ro*KT*sqrt(Tmax-Tmin);
  Serial.print(Rs);
  Serial.println("/n mm/dia  ");
  Serial.print("LA EVAPOTRANSPIRACION DE ESTE DIA ES DE :  ");
  ETo=0.0135*(Tmedia+17.78)*Rs;
  Serial.print(ETo);
  Serial.println("/n mm/dia  ");
  delay(100);
  Tmedia=0;
  Tmax=0;
  Tmin=100;
  Serial.println("");
  Serial.print("PRECIPITACION ACUMULADA DEL DIA   ");
  Serial.print(Precipitacion);
  Serial.println(" mm");
  PrecipitacionMes=Precipitacion+PrecipitacionMes;
  Serial.print("PRECIPITACION ACUMULADA DEL MES   ");
  Serial.print(PrecipitacionMes);
  Serial.println(" mm");
  Precipitacion=0;
  cuentaPrecipitacion=0;
  cuentaPrecipitacionAnt=0;
  ///////////////////////////////////////////////////////////
} //end for j

///////////////////////RESULTADOS MENSUALES Y APLICACION DEL SISTEMA ///////////////////////////////////////
//////////////////////CALCULANDO LA NECESIDAD DE RIEGO//////////////////////////////
  Serial.print("LA EVAPOTRANSPIRACION DEL MES FUE DE :   ");
  Serial.print(EToMes);
  Serial.println(" mm/mes ");
  Serial.println(" AHORA VAMOS A CALCULAR LA NECESIDAD DE RIEGO PARA EL MES SIGUIENTE ");
  
  //Pe = 0,75· (Pt – 5 mm) ;   Pt se calcula con el sensor del pluviometro pero por defecto en este codigo simularemos dias de verano sin lluvias por tanto Pe=3,75
  //double Pe = 0.75*(PrecipitacionMes - 5);
  //double NecesidadDeRiego = ((EToMes*Kc)/0.85)-(Pe);
  
  double NecesidadDeRiego = ((EToMes*Kc)/0.85)+3.75;
  Serial.print("LAa necesidad de riego es de  ");
  Serial.print(NecesidadDeRiego);
  Serial.println(" mm/mes ");
  Serial.println("LA PRECIPITACION DEL MES FUE DE   ");
  Serial.print(PrecipitacionMes);
  Serial.println("ESTO SIGNIFICA QUE CADA CULTIVO DE VID PIERDE ESTE AGUA MENSUALMENTE A TRAVES DE LA EVAPORACION  ");
  Serial.println("EL CONSUMO HIDRICO MENSUAL DE CADA CEPA DE VID  ");
  Serial.println("SI TENEMOS 6000 CEPAS NUESTRA VALVULA DEBERA PROPORCIONAR " );
  double RiegoMensual = NecesidadDeRiego * 6000;
  Serial.print(RiegoMensual);
  Serial.println (" mm/mes");
  Serial.println("POR TANTO DIARIAMENTE NECESITAREMOS");
  double RiegoDiario = RiegoMensual/30;
  Serial.print(RiegoDiario);
  Serial.println(" litros diarios");
  Serial.println("COMO NUESTRA VALVULA TIENE UN CAUDAL DE 9 METROS CUBICOS HORA");
  Serial.print("DEBERA ESTAR FUNCIONANDO ACTIVADA ");
  double TiempoValvulaON= RiegoDiario/9000;
  double TiempoValvulaONMinutos=TiempoValvulaON*60;
  int TiempoValvulaONSegundos=TiempoValvulaONMinutos*60;
  int TiempoValvulaONMs=TiempoValvulaONSegundos*1000;
  Serial.print(TiempoValvulaONMinutos);
  Serial.println("  minutos activada diariamente");
  EToMes=0;
  Serial.println("");
  
}// end for k
}// end loop() 
